diff --git a/src/main/java/net/minecraft/core/block/WoolBlock.java b/src/main/java/net/minecraft/core/block/WoolBlock.java
new file mode 100644
index 000000000..1cf8852de
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/WoolBlock.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+public class WoolBlock extends Block
+{
+    public WoolBlock(String key, String namespaceId, int id) {
+
+        super(key, namespaceId, id, Material.cloth);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    {
+        return new ItemStack[] { new ItemStack(this, 1, meta) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockWorkbench.java b/src/main/java/net/minecraft/core/block/WorkbenchBlock.java
similarity index 58%
rename from src/main/java/net/minecraft/core/block/BlockWorkbench.java
rename to src/main/java/net/minecraft/core/block/WorkbenchBlock.java
index 6621d0d0c..3ff1605f6 100644
--- a/src/main/java/net/minecraft/core/block/BlockWorkbench.java
+++ b/src/main/java/net/minecraft/core/block/WorkbenchBlock.java
@@ -1,23 +1,23 @@
 package net.minecraft.core.block;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, Material, World, EntityPlayer
+//            Block, Material, World, Player
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockWorkbench extends Block
+public class WorkbenchBlock extends Block
 {
 
-	public BlockWorkbench(String key, int id)
+	public WorkbenchBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.wood);
+        super(key, namespaceId, id, Material.wood);
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide)
         {
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
rename to src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
index a06d6fe6f..0f92e779d 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/src/main/java/net/minecraft/core/block/entity/BasketBlockEntity.java
@@ -2,20 +2,20 @@ package net.minecraft.core.block.entity;
 
 import java.util.*;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet140TileEntityData;
+import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public class TileEntityBasket extends TileEntity
+public class BasketBlockEntity extends BlockEntity
 {
     private int numUnitsInside = 0;
     private final Map<BasketEntry, Integer> contents = new HashMap<>();
@@ -42,7 +42,7 @@ public class TileEntityBasket extends TileEntity
 
         contents.clear();
 
-        worldObj.notifyBlockChange(x, y, z, Block.basket.id);
+        worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
         updateNumUnits();
     }
 
@@ -76,7 +76,7 @@ public class TileEntityBasket extends TileEntity
         final float f1 = rand.nextFloat() * 0.8F + 0.1F;
         final float f2 = rand.nextFloat() * 0.8F + 0.1F;
 
-        final EntityItem entityitem = new EntityItem(worldObj, x + f, y + f1, z + f2, itemstack);
+        final ItemEntity entityitem = new ItemEntity(worldObj, x + f, y + f1, z + f2, itemstack);
         final float f3 = 0.05F;
         entityitem.xd = (float) rand.nextGaussian() * f3;
         entityitem.yd = (float) rand.nextGaussian() * f3 + 0.25F;
@@ -94,7 +94,7 @@ public class TileEntityBasket extends TileEntity
         return 27 * 64;
     }
 
-	public void givePlayerAllItems(final World world, final EntityPlayer player) {
+	public void givePlayerAllItems(final World world, final Player player) {
 		List<BasketEntry> toRemove = new ArrayList<>();
 
 		for(Map.Entry<BasketEntry, Integer> entry : contents.entrySet()) {
@@ -115,7 +115,7 @@ public class TileEntityBasket extends TileEntity
 		}
 
 		updateNumUnits();
-		worldObj.notifyBlockChange(x, y, z, Block.basket.id);
+		worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
 	}
 
     @Override
@@ -139,9 +139,9 @@ public class TileEntityBasket extends TileEntity
     {
         if (worldObj == null || worldObj.isClientSide) return;
 
-        final AABB aabb = AABB.getBoundingBoxFromPool(x, y, z, x + 1, y + 2, z + 1);
+        final AABB aabb = AABB.getTemporaryBB(x, y, z, x + 1, y + 2, z + 1);
 
-        final List<Entity> entities = worldObj.getEntitiesWithinAABB(EntityItem.class, aabb);
+        final List<Entity> entities = worldObj.getEntitiesWithinAABB(ItemEntity.class, aabb);
 
         boolean shouldUpdate = false;
 
@@ -149,7 +149,7 @@ public class TileEntityBasket extends TileEntity
         {
             for (final Entity e : entities)
             {
-                final EntityItem entity = (EntityItem) e;
+                final ItemEntity entity = (ItemEntity) e;
                 if (entity.item != null && entity.item.stackSize > 0 && entity.basketPickupDelay == 0)
                 {
                     shouldUpdate = importItemStack(entity.item);
@@ -164,7 +164,7 @@ public class TileEntityBasket extends TileEntity
 
         if (shouldUpdate)
         {
-            worldObj.notifyBlockChange(x, y, z, Block.basket.id);
+            worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
             updateNumUnits();
         }
     }
@@ -201,7 +201,7 @@ public class TileEntityBasket extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new Packet140TileEntityData(this);
+        return new BlockEntityDataPacket(this);
     }
 
     private static final class BasketEntry
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityBlastFurnace.java b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityBlastFurnace.java
rename to src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
index 6af468353..14913b32c 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityBlastFurnace.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
@@ -2,36 +2,35 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, BlockFurnace, FurnaceRecipes,
-//            Item, Block, Material, EntityPlayer
+//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
+//            NBTTagList, World, FurnaceBlock, FurnaceRecipes,
+//            Item, Block, Material, Player
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockBlastFurnace;
+import net.minecraft.core.block.BlastFurnaceBlock;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.crafting.LookupFuelFurnaceBlast;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.data.registry.recipe.RecipeGroup;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Container;
 
 import java.util.List;
 
-public class TileEntityBlastFurnace extends TileEntityFurnace
-        implements IInventory
+public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
+        implements Container
 {
 
 
-    public TileEntityBlastFurnace()
+    public BlastFurnaceBlockEntity()
     {
         super();
         maxCookTime = 100;
     }
 
     @Override
-	public String getInvName()
+	public String getName()
     {
         return "BlastFurnace";
     }
@@ -41,7 +40,7 @@ public class TileEntityBlastFurnace extends TileEntityFurnace
     {
         super.readFromNBT(nbttagcompound);
         ListTag nbttaglist = nbttagcompound.getList("Items");
-        furnaceItemStacks = new ItemStack[getSizeInventory()];
+        furnaceItemStacks = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
             CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
@@ -91,12 +90,12 @@ public class TileEntityBlastFurnace extends TileEntityFurnace
         }
         if(worldObj != null && !worldObj.isClientSide)
         {
-        	if(worldObj.getBlockId(x, y, z) == Block.furnaceBlastIdle.id) {
+        	if(worldObj.getBlockId(x, y, z) == Blocks.FURNACE_BLAST_IDLE.id) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Block.netherrack.id) {
+            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.NETHERRACK.id) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
-            			BlockBlastFurnace.updateFurnaceBlockState(true, worldObj, x, y, z);
+            			BlastFurnaceBlock.updateFurnaceBlockState(true, worldObj, x, y, z);
             			furnaceUpdated = true;
             		}
             	}
@@ -138,13 +137,13 @@ public class TileEntityBlastFurnace extends TileEntityFurnace
         }
         if(furnaceUpdated)
         {
-            onInventoryChanged();
+            setChanged();
         }
     }
 
     @Override
     protected void updateFurnace(){
-        BlockBlastFurnace.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
+        BlastFurnaceBlock.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
     }
 
     private boolean canSmelt()
@@ -174,7 +173,7 @@ public class TileEntityBlastFurnace extends TileEntityFurnace
         {
             return false;
         }
-        if(furnaceItemStacks[2].stackSize < getInventoryStackLimit() && furnaceItemStacks[2].stackSize < furnaceItemStacks[2].getMaxStackSize())
+        if(furnaceItemStacks[2].stackSize < getMaxStackSize() && furnaceItemStacks[2].stackSize < furnaceItemStacks[2].getMaxStackSize())
         {
             return true;
         }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
similarity index 66%
rename from src/main/java/net/minecraft/core/block/entity/TileEntity.java
rename to src/main/java/net/minecraft/core/block/entity/BlockEntity.java
index a21ea60a5..9a8b24ee1 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Block;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.block.piston.TileEntityPistonMoving;
+import net.minecraft.core.block.piston.MovingPistonBlockEntity;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.world.World;
 
@@ -10,14 +10,14 @@ import java.util.HashMap;
 import java.util.Map;
 
 // Referenced classes of package net.minecraft.src:
-//            NBTTagCompound, World, Block, TileEntityFurnace, 
-//            TileEntityChest, TileEntityRecordPlayer, TileEntityDispenser, TileEntitySign, 
-//            TileEntityMobSpawner, TileEntityNote, TileEntityPiston
+//            NBTTagCompound, World, Block, FurnaceBlockEntity,
+//            ChestBlockEntity, JukeboxBlockEntity, DispenserBlockEntity, SignBlockEntity,
+//            MobSpawnerBlockEntity, NoteBlockEntity, TileEntityPiston
 
-public class TileEntity
+public class BlockEntity
 {
 
-    public TileEntity()
+    public BlockEntity()
     {
     }
 
@@ -61,15 +61,15 @@ public class TileEntity
     {
     }
 
-    public static TileEntity createAndLoadEntity(CompoundTag nbttagcompound)
+    public static BlockEntity createAndLoadEntity(CompoundTag nbttagcompound)
     {
-        TileEntity tileentity = null;
+        BlockEntity tileentity = null;
         try
         {
             Class class1 = (Class)nameToClassMap.get(nbttagcompound.getString("id"));
             if(class1 != null)
             {
-                tileentity = (TileEntity)class1.newInstance();
+                tileentity = (BlockEntity)class1.newInstance();
             }
         }
         catch(Exception exception)
@@ -81,7 +81,7 @@ public class TileEntity
             tileentity.readFromNBT(nbttagcompound);
         } else
         {
-            System.out.println("Skipping TileEntity with id " + nbttagcompound.getString("id"));
+            System.out.println("Skipping BlockEntity with id " + nbttagcompound.getString("id"));
         }
         return tileentity;
     }
@@ -96,7 +96,7 @@ public class TileEntity
         return worldObj.getBlockMetadata(x, y, z);
     }
 
-    public void onInventoryChanged()
+    public void setChanged()
     {
         if(worldObj != null)
         {
@@ -147,21 +147,21 @@ public class TileEntity
 
     static 
     {
-        addMapping(TileEntityFurnace.class, "Furnace");
-        addMapping(TileEntityChest.class, "Chest");
-        addMapping(TileEntityRecordPlayer.class, "RecordPlayer");
-        addMapping(TileEntityDispenser.class, "Trap");
-        addMapping(TileEntitySign.class, "Sign");
-        addMapping(TileEntityMobSpawner.class, "MobSpawner");
-        addMapping(TileEntityNote.class, "Music");
-        addMapping(TileEntityPistonMoving.class, "Piston");
-        addMapping(TileEntityBlastFurnace.class, "BlastFurnace");
-        addMapping(TileEntitySensor.class, "Sensor");
-        addMapping(TileEntityTrommel.class, "Trommel");
-        addMapping(TileEntityBasket.class, "Basket");
-        addMapping(TileEntityFlag.class, "Flag");
-        addMapping(TileEntitySeat.class, "Seat");
-        addMapping(TileEntityFlowerJar.class, "FlowerJar");
-        addMapping(TileEntityMeshGold.class, "MeshGold");
+        addMapping(FurnaceBlockEntity.class, "Furnace");
+        addMapping(ChestBlockEntity.class, "Chest");
+        addMapping(JukeboxBlockEntity.class, "RecordPlayer");
+        addMapping(DispenserBlockEntity.class, "Trap");
+        addMapping(SignBlockEntity.class, "Sign");
+        addMapping(MobSpawnerBlockEntity.class, "MobSpawner");
+        addMapping(NoteBlockEntity.class, "Music");
+        addMapping(MovingPistonBlockEntity.class, "Piston");
+        addMapping(BlastFurnaceBlockEntity.class, "BlastFurnace");
+        addMapping(SensorBlockEntity.class, "Sensor");
+        addMapping(TrommelBlockEntity.class, "Trommel");
+        addMapping(BasketBlockEntity.class, "Basket");
+        addMapping(FlagBlockEntity.class, "Flag");
+        addMapping(SeatBlockEntity.class, "Seat");
+        addMapping(FlowerJarBlockEntity.class, "FlowerJar");
+        addMapping(GoldMeshBlockEntity.class, "MeshGold");
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
similarity index 60%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
rename to src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
index 4d9912364..f6f7dbd4c 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
@@ -2,55 +2,55 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound, 
-//            NBTTagList, World, EntityPlayer
+//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
+//            NBTTagList, World, Player
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Container;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.player.inventory.InventorySorter;
 
-public class TileEntityChest extends TileEntity
-    implements IInventory
+public class ChestBlockEntity extends BlockEntity
+    implements Container
 {
 
-    public TileEntityChest()
+    public ChestBlockEntity()
     {
         chestContents = new ItemStack[36];
     }
 
     @Override
-	public int getSizeInventory()
+	public int getContainerSize()
     {
         return 27;
     }
 
     @Override
-	public ItemStack getStackInSlot(int i)
+	public ItemStack getItem(int index)
     {
-        return chestContents[i];
+        return chestContents[index];
     }
 
     @Override
-	public ItemStack decrStackSize(int i, int j)
+	public ItemStack removeItem(int index, int takeAmount)
     {
-        if(chestContents[i] != null)
+        if(chestContents[index] != null)
         {
-            if(chestContents[i].stackSize <= j)
+            if(chestContents[index].stackSize <= takeAmount)
             {
-                ItemStack itemstack = chestContents[i];
-                chestContents[i] = null;
-                onInventoryChanged();
+                ItemStack itemstack = chestContents[index];
+                chestContents[index] = null;
+                setChanged();
                 return itemstack;
             }
-            ItemStack itemstack1 = chestContents[i].splitStack(j);
-            if(chestContents[i].stackSize <= 0)
+            ItemStack itemstack1 = chestContents[index].splitStack(takeAmount);
+            if(chestContents[index].stackSize <= 0)
             {
-                chestContents[i] = null;
+                chestContents[index] = null;
             }
-            onInventoryChanged();
+            setChanged();
             return itemstack1;
         } else
         {
@@ -59,18 +59,18 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public void setInventorySlotContents(int i, ItemStack itemstack)
+	public void setItem(int index, ItemStack itemstack)
     {
-        chestContents[i] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getInventoryStackLimit())
+        chestContents[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
         {
-            itemstack.stackSize = getInventoryStackLimit();
+            itemstack.stackSize = getMaxStackSize();
         }
-        onInventoryChanged();
+        setChanged();
     }
 
     @Override
-	public String getInvName()
+	public String getName()
     {
         return "Chest";
     }
@@ -80,7 +80,7 @@ public class TileEntityChest extends TileEntity
     {
         super.readFromNBT(nbttagcompound);
         ListTag nbttaglist = nbttagcompound.getList("Items");
-        chestContents = new ItemStack[getSizeInventory()];
+        chestContents = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
             CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
@@ -112,15 +112,15 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public int getInventoryStackLimit()
+	public int getMaxStackSize()
     {
         return 64;
     }
 
     @Override
-	public boolean canInteractWith(EntityPlayer entityplayer)
+	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockTileEntity(x, y, z) != this)
+        if(worldObj.getBlockEntity(x, y, z) != this)
         {
             return false;
         }
@@ -128,7 +128,7 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-    public void sortInventory() {
+    public void sortContainer() {
         InventorySorter.sortInventory(chestContents);
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
rename to src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
index bac18fe2a..02643c2c7 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
@@ -1,58 +1,58 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Container;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound, 
-//            NBTTagList, World, EntityPlayer
+//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
+//            NBTTagList, World, Player
 
-public class TileEntityDispenser extends TileEntity
-    implements IInventory
+public class DispenserBlockEntity extends BlockEntity
+    implements Container
 {
 
-    public TileEntityDispenser()
+    public DispenserBlockEntity()
     {
         dispenserContents = new ItemStack[9];
         dispenserRandom = new Random();
     }
 
     @Override
-	public int getSizeInventory()
+	public int getContainerSize()
     {
         return 9;
     }
 
     @Override
-	public ItemStack getStackInSlot(int i)
+	public ItemStack getItem(int index)
     {
-        return dispenserContents[i];
+        return dispenserContents[index];
     }
 
     @Override
-	public ItemStack decrStackSize(int i, int j)
+	public ItemStack removeItem(int index, int takeAmount)
     {
-        if(dispenserContents[i] != null)
+        if(dispenserContents[index] != null)
         {
-            if(dispenserContents[i].stackSize <= j)
+            if(dispenserContents[index].stackSize <= takeAmount)
             {
-                ItemStack itemstack = dispenserContents[i];
-                dispenserContents[i] = null;
-                onInventoryChanged();
+                ItemStack itemstack = dispenserContents[index];
+                dispenserContents[index] = null;
+                setChanged();
                 return itemstack;
             }
-            ItemStack itemstack1 = dispenserContents[i].splitStack(j);
-            if(dispenserContents[i].stackSize <= 0)
+            ItemStack itemstack1 = dispenserContents[index].splitStack(takeAmount);
+            if(dispenserContents[index].stackSize <= 0)
             {
-                dispenserContents[i] = null;
+                dispenserContents[index] = null;
             }
-            onInventoryChanged();
+            setChanged();
             return itemstack1;
         } else
         {
@@ -74,16 +74,16 @@ public class TileEntityDispenser extends TileEntity
 
         if(i >= 0)
         {
-            ItemStack stack = getStackInSlot(i);
+            ItemStack stack = getItem(i);
             if (stack.getItem() instanceof IDispensable) {
                 IDispensable dispensable = (IDispensable) stack.getItem();
                 if (dispensable.isRemovedOnDispense()) {
-                    return decrStackSize(i, 1);
+                    return removeItem(i, 1);
                 } else {
                     return stack;
                 }
             }
-            return decrStackSize(i, 1);
+            return removeItem(i, 1);
         }
         else
         {
@@ -92,18 +92,18 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public void setInventorySlotContents(int i, ItemStack itemstack)
+	public void setItem(int index, ItemStack itemstack)
     {
-        dispenserContents[i] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getInventoryStackLimit())
+        dispenserContents[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
         {
-            itemstack.stackSize = getInventoryStackLimit();
+            itemstack.stackSize = getMaxStackSize();
         }
-        onInventoryChanged();
+        setChanged();
     }
 
     @Override
-	public String getInvName()
+	public String getName()
     {
         return "Trap";
     }
@@ -113,7 +113,7 @@ public class TileEntityDispenser extends TileEntity
     {
         super.readFromNBT(nbttagcompound);
         ListTag nbttaglist = nbttagcompound.getList("Items");
-        dispenserContents = new ItemStack[getSizeInventory()];
+        dispenserContents = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
             CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
@@ -146,15 +146,15 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public int getInventoryStackLimit()
+	public int getMaxStackSize()
     {
         return 64;
     }
 
     @Override
-	public boolean canInteractWith(EntityPlayer entityplayer)
+	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockTileEntity(x, y, z) != this)
+        if(worldObj.getBlockEntity(x, y, z) != this)
         {
             return false;
         }
@@ -162,7 +162,7 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-    public void sortInventory() {
+    public void sortContainer() {
         // Do nothing
     }
 
